import java.nio.*;
import java.nio.channels.*;
import java.io.*;

public class FileChannelTest4 {

    public FileChannelTest4(String filename) {
        access(filename);
    }

    private void access(String filename){

        try{
            RandomAccessFile raFile = new RandomAccessFile(filename, "rw");
            FileChannel channel = raFile.getChannel();

            // Acquire Lock
            System.out.println("Acquire Lock.");
            FileLock lock = channel.lock();
            System.out.println("Lock: " + lock);

            ByteBuffer buffer = ByteBuffer.allocate(10);
            channel.read(buffer);

            System.out.println("Read 10 bytes");
            ByteBufferUtility.printByteBuffer(buffer);
            
            javax.swing.JOptionPane.showMessageDialog(null, "Release Lock?");
            lock.release();

            javax.swing.JOptionPane.showMessageDialog(null, "Close File?");
            channel.close();

            System.exit(0);
        }catch(FileNotFoundException ex){
            ex.printStackTrace();
        }catch(IOException ex){
            ex.printStackTrace();
        }
    }

    public static void main(String[] args){
        new FileChannelTest4(args[0]);
    }
}
